<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>Database Test Documentation</TITLE>
    </HEAD>

    <BODY>
        <H1 align="center">The Database Insertion Test</H1>

        <h2>Test objectives</h2>
		<UL>
		<LI>Measurement of rates of insertion with various dimensions of the insertion data e.g. 1,10,100,1000 objects.</LI>
		<LI>Validation of the data inserted against the input ilwd.
		</UL>
		
		<H2>APIs affected by this test</h2>
		<UL>
		<LI><font color='blue'>managerAPI</font>: directs processing of the insertion and query user commands to the ligolwAPI and metadataAPI
			and returns the user command status to the user.</LI><p>
		<LI><font color='blue'>ligolwAPI</font>: 
			<UL>
			<LI>Retrieves the data to be ingested from the specified url to ilwd object and sends the ilwd
			to the metadataAPI for insertion.
			<LI>Converts the query results in ilwd from the metadataAPI into xml and delivers the output to the specified
				url</LI>
			</UL><p>
		<LI><font color='blue'>metadataAPI</font>: 
			<UL>
			<LI>insert the metadata ilwd data from ligolwAPI into the specified database.</LI>
			<LI>process the queries, retrieve the result rows from database and send them as ilwd object to ligolwAPI.</LI>
			</UL>
		</UL>
		
		
        <H2>Setup</H2>
        <P>Choose a directory to install the tests scripts.  
		<UL>
		<LI>The script files are:
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/metadataAPI/tcl/test/metadata.test?rev=HEAD;content-type=text%2Fplain'>metadata.test</a></font>
        - main driver script</li>
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/metadataAPI/tcl/test/getMetaData.tcl?rev=HEAD;content-type=text%2Fplain'>getMetaData.tcl</a></font>
        - getMetaData user cmd test driver</li>
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/metadataAPI/tcl/test/putMetaData.tcl?rev=HEAD;content-type=text%2Fplain'>putMetaData.tcl</a></font>
        - putMetaData user cmd test driver</li>
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/dbms/db2/ilwdnew/get_refs.sql?rev=HEAD;content-type=text%2Fplain'>get_refs.sql</a></font>
        - extract unique Ids for generation of ilwds</li>
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/dbms/db2/ilwdnew/xrefs.tcl?rev=HEAD;content-type=text%2Fplain'>xrefs.tcl</a></font>
        - generates include files (.h) based on the data inserted</li>     
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/metadataAPI/tcl/test/ilwdValidate.tcl?rev=HEAD;content-type=text%2Fplain'>ilwdValidate.tcl</a></font>
        - compares ilwds in ilwd and xml formats </li>
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/metadataAPI/tcl/test/createplot.tcl?rev=HEAD;content-type=text%2Fplain'>createplot.tcl</a></font>
        - parses metadata log to generate insertion rate files</li>
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/metadataAPI/tcl/test/dbstats.tcl?rev=HEAD;content-type=text%2Fplain'>dbstats.tcl</a></font>
        - compares current results with previous</li>
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/metadataAPI/tcl/test/analyseInsert.tcl?rev=HEAD;content-type=text%2Fplain'>analyseInsert.tcl</a></font>
        - extracts insertion logs and invokes post processing via createplot.tcl and dbstats.tcl. </li>
                        	
		<P>
		<LI>ilwd generating source files and Makefile are required for all tables; they can be checked out from
        <a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/dbms/db2/ilwdnew'>ldas cvs repository under dbms</a>
		<pre><font color='brown'>
                
		coinc_snglilwd.cc         multi_burstilwd.cc      sngl_mimeilwd.cc
		commonilwd.cc             multi_inspiralilwd.cc   sngl_ringdownilwd.cc
		filter_paramsilwd.cc      process_paramsilwd.cc   sngl_transdatailwd.cc
		filterilwd.cc             processilwd.cc          sngl_unmodeled_vilwd.cc
		frameset_chanlistilwd.cc  runlistilwd.cc          sngl_unmodeledilwd.cc
		frameset_locilwd.cc       segment_definerilwd.cc  summ_commentilwd.cc
		frameset_writerilwd.cc    segmentilwd.cc          summ_csdilwd.cc
		framesetilwd.cc           sngl_burstilwd.cc       summ_mimeilwd.cc
		gds_triggerilwd.cc        sngl_datasourceilwd.cc  summ_spectrumilwd.cc
		sngl_dperiodicilwd.cc     summ_statisticsilwd.cc
		sngl_inspiralilwd.cc      summ_valueilwd.cc	  Makefile
		</font></pre></LI>

		<p><i>Note: gcc compiler environment must be present for ilwd source code to be compiled into executables.</i><p>
		
		<LI>Environment variables:<p>
		 Environment variable SSH_AUTH_SOCK is required to allow execution of scripts on dataserver to retrieve logs.
		 To set this, on the ldas gateway, find out the name of the ldas agent by running the ldas utility ldasagent.
		 Then setenv SSH_AUTH_SOCK to the output of ldasagent if an agent exists.
		 Then login to metaserver; verify that the environment variable is set before running the test.
		 </LI>
        
        <P><B>Note:</B> At all the sites, the required script files are installed at <CODE>/ldas_usr/ldas/test/database</CODE>.  
		</UL>
        <H2>Test Execution</H2>
		The test must be run from the host where db2 resides, i.e. <font color='brown'>metaserver</font> and run in the scripts directory e.g. /ldas_usr/ldas/test/database.
		
		<p>cd /ldas_usr/ldas/test/database<p>
		
        <B>Usage:</B> <CODE>metadata.test [options] >& metadatatest.log & </CODE>

        <P><TABLE border=1 cellspacing=0 cellpadding=10>
            <TR>
                <TH><B>Option</B>
                <TH><B>Description</B>
            <TR>
                <TD valign=top><CODE>&lt;dsname&gt;</CODE>
                <TD>database name for the test
            <TR>
                <TD valign=top><CODE>&lt;dims set&gt;</CODE>
                <TD>set of ilwd dimensions, comma separated e.g. 1,10,100,1000
            <TR>
                <TD valign=top><CODE>&lt;previous result directory&gt;</CODE>
                <TD>relative location of directory of previous result for comparision e.g. results-1107
            <TR>
                <TD valign=top><CODE>&lt;validate [ 0 | 1 ]&gt;</CODE>
                <TD>boolean flag to indicate if validation should be done on data inserted; if so a getMetaData command
				is issued to retrieve the data and validation invoked. 
            <TR>
                <TD valign=top><CODE>no options</CODE>
                <TD>shows the required arguments.
        </TABLE>

		<p>
		<H2>Test Validation:</H2>
		The test is divided into the following phases and fully automated to execute all the phases. Validation for each
        phase is described.<p>
		<OL>
		<LI><font color='magenta'>Insertion phase</font><p>
			The database is cleared out. 
			The tables are divided into 4 levels according to their dependency on previous tables. Insertions for table data
			at each level are completed before the next level. After one level is inserted, scripts are ran to extract
			inserted information to generate include files (.h) . The next level ilwds are generated by compiling the source code
			with the include files and running the executables to output ilwds that reference inserted data. If the ilwds do 
			not compile properly, most likely the include files are not being generated properly; it is best to terminate the
			test and examine why the database extraction did not result in the correct include files. </LI>
		<p>
		<LI><font color='magenta'>Query and ilwd validation phase</font><p>
			If validate option is 1, a query is made to extract data from each of the tables into xml. The result xml is
			compared against the original ilwd to verify that all input data in the ilwd is the same as in the database.
			<i>Since the IBM DB2 does not support unsigned integers, there will a mismatch for ilwd types INT_2U, INT_4U and
			INT_8U.</i>&nbsp; The validation reports are directed to stdout.<p>There is a line per table:
			e.g. <font color='green'>Test passed for table sngl_datasource.</font><p>and the end result:
			<font color='green'>All tables passed.</font></LI> 
		<p>
		<LI><font color='magenta'>Insertion Rates Computation</font><p>
			The logs generated during insertion phase are extracted from ldas logs and parsed to generate output files 
			correlating ilwd dims to insertion cputime, walltime and insertion rate in number of rows/sec. The rates are already
			computed by the metadataAPI and recorded in the logs. 3 files are output: <p>
			<ul>
			<li>insert&lt;start-gpstime&gt;-&lt;end-gpstime&gt;.log.html, - insertion log file extracted from metadataAPI, 
			e.g. <font color='brown'>insert691959297-691962080.log.html</font></li><p>
			<li>&lt;site&gt;&lt;dbname&gt;&lt;ldas-version&gt;&lt;yyyymmdd&gt;.html - html file of table, dims vs cputime, walltime,insertion rates
			e.g. <font color='brown'>ldas-dev.ldas_tst.ldas-0.0.23.20011209.html</font></li><p>
			<li>insert.&lt;dbname&gt;&lt;ldas-version&gt;&lt;yyyymmdd&gt; text format of table, dims vs cputime, walltime,insertion rates.
			e.g. <font color='brown'>insert.ldas_tst.ldas-0.0.23.20011209.txt</font></li><p>
			<li>createplot.log - output log from createplot.tcl; if there are missing dims, errors are reported here.</li>
			</ul><p>
		<LI><font color='magenta'>Insertion Rate Analysis</font><p>
			The current insertion file output (.txt file) is used to compare against results from 3 previous releases to see if the rates are within
			10% standard deviation; if so this implies a no change in rate and the test <font color='green'>passes</font>. 
			If not, the test <font color='red'>fails</font>. There are 3 output file from the comparision:
			<ul>
			<li>insert&lt;dbname&gt;&lt;ldas-version&gt;&lt;yyyymmdd&gt.stats.m.n.r - e.g. <i>insert.dev_1.ldas-1.2.3.20040910.stats.1.2.0</i>
            is the output statistical comparison of this result vs that of ldas 1.2.0, and <i>insert.dev_1.ldas-1.2.3.20040910.stats.1.1.0</i>
            is the output statistical comparison of this result vs that of ldas 1.1.0.            
            </li>
			</ul>
		</OL>	
    </BODY>
</HTML>

